/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	SocketStream.h
 *
 *****************************************************************************/

// SOL++2000
// 1999.08.10 Modified

#ifndef _SOL_SOCKET
#include <sol\Socket.h>
#endif

#ifndef _SOL_STRINGBUFFER
#include <sol\StringBuffer.h>
#endif

#ifndef _SOL_INETADDRESS
#include <sol\InetAddress.h>
#endif

#ifndef _SOL_SOCKETSTREAM
#define _SOL_SOCKETSTREAM

class SocketStream :public Socket {
	char	line[1024];
	int		startPos;
	int		contentSize;
 public:
    SocketStream();
    SocketStream(int domain, int protocol);

    ~SocketStream();
    SocketStream* accept(sockaddr* addr, int* size);
    SocketStream* accept(int port, unsigned long address);

	SocketStream* accept(InetAddress& addr);
    SOCKET  create(int domain, int protocol);
    int		connect(int port, hostent* hostEntry);
    int		connect(int port, unsigned long address);
	int		connect(sockaddr* addr, size_t size);

	int		connect(InetAddress& addr);
	int		readLine(StringBuffer& buffer);

	int		getLine(StringBuffer& buffer);
};

#endif
